diff --git a/include/gpac/internal/isomedia_dev.h b/include/gpac/internal/isomedia_dev.h
index cfbc7b1dea..5e8cfa7d99 100644
--- a/include/gpac/internal/isomedia_dev.h
+++ b/include/gpac/internal/isomedia_dev.h
@@ -185,6 +185,11 @@ enum
 	GF_ISOM_BOX_TYPE_AV1C = GF_4CC('a', 'v', '1', 'C'),
 	GF_ISOM_BOX_TYPE_AV01 = GF_4CC('a', 'v', '0', '1'),
 
+	/* WebM */
+	GF_ISOM_BOX_TYPE_VPCC = GF_4CC('v', 'p', 'c', 'C'),
+	GF_ISOM_BOX_TYPE_VP08 = GF_4CC('v', 'p', '0', '8'),
+	GF_ISOM_BOX_TYPE_VP09 = GF_4CC('v', 'p', '0', '9'),
+
 	/*LASeR extension*/
 	GF_ISOM_BOX_TYPE_LSRC	= GF_4CC( 'l', 's', 'r', 'C' ),
 	GF_ISOM_BOX_TYPE_LSR1	= GF_4CC( 'l', 's', 'r', '1' ),
@@ -1137,6 +1142,12 @@ typedef struct
 	GF_AV1Config *config;
 } GF_AV1ConfigurationBox;
 
+typedef struct
+{
+	GF_ISOM_FULL_BOX
+	GF_VPConfig *config;
+} GF_VPConfigurationBox;
+
 typedef struct
 {
 	GF_ISOM_BOX
@@ -1159,6 +1170,9 @@ typedef struct
 	GF_HEVCConfigurationBox *lhvc_config;
 	/*av1 extension*/
 	GF_AV1ConfigurationBox *av1_config;
+	/*vp8-9 extension*/
+	GF_VPConfigurationBox *vp_config;
+
 
 	/*ext descriptors*/
 	GF_MPEG4ExtensionDescriptorsBox *descr;
diff --git a/include/gpac/isomedia.h b/include/gpac/isomedia.h
index 2d9c96ec23..82ab56c5c6 100644
--- a/include/gpac/isomedia.h
+++ b/include/gpac/isomedia.h
@@ -311,6 +311,10 @@ enum
 	/*AV1 media type*/
 	GF_ISOM_SUBTYPE_AV01 = GF_4CC('a', 'v', '0', '1'),
 
+	/* VP */
+	GF_ISOM_SUBTYPE_VP08 = GF_4CC('v', 'p', '0', '8'),
+	GF_ISOM_SUBTYPE_VP09 = GF_4CC('v', 'p', '0', '9'),
+
 	/*3GPP(2) extension subtypes*/
 	GF_ISOM_SUBTYPE_3GP_H263	= GF_4CC( 's', '2', '6', '3' ),
 	GF_ISOM_SUBTYPE_3GP_AMR		= GF_4CC( 's', 'a', 'm', 'r' ),
@@ -1128,7 +1132,7 @@ Use streamDescriptionIndex to specify the desired stream (if several)*/
 GF_Err gf_isom_add_sample_reference(GF_ISOFile *the_file, u32 trackNumber, u32 StreamDescriptionIndex, GF_ISOSample *sample, u64 dataOffset);
 
 /*set the duration of the last media sample. If not set, the duration of the last sample is the
-duration of the previous one if any, or media TimeScale (default value). This does not modify the edit list if any, 
+duration of the previous one if any, or media TimeScale (default value). This does not modify the edit list if any,
 you must modify this using gf_isom_set_edit_segment*/
 GF_Err gf_isom_set_last_sample_duration(GF_ISOFile *the_file, u32 trackNumber, u32 duration);
 
@@ -1989,6 +1993,9 @@ GF_HEVCConfig *gf_isom_lhvc_config_get(GF_ISOFile *the_file, u32 trackNumber, u3
 /*gets AV1 config - user is responsible for deleting it*/
 GF_AV1Config *gf_isom_av1_config_get(GF_ISOFile *the_file, u32 trackNumber, u32 DescriptionIndex);
 
+/*gets VP config - user is responsible for deleting it*/
+GF_VPConfig *gf_isom_vp_config_get(GF_ISOFile *the_file, u32 trackNumber, u32 DescriptionIndex);
+
 /*return true if track dependencies implying extractors or implicit reconstruction are found*/
 Bool gf_isom_needs_layer_reconstruction(GF_ISOFile *file);
 
diff --git a/include/gpac/mpeg4_odf.h b/include/gpac/mpeg4_odf.h
index b0266edda8..73182c4f57 100644
--- a/include/gpac/mpeg4_odf.h
+++ b/include/gpac/mpeg4_odf.h
@@ -1010,6 +1010,29 @@ typedef struct
 	GF_List *obu_array; /*GF_AV1_OBUArrayEntry*/
 } GF_AV1Config;
 
+
+/*! VP8-9 config vpcC */
+typedef struct
+{
+	u8	profile;
+	u8	level;
+
+	/*unsigned int(4)     bitDepth;
+	unsigned int(3)     chromaSubsampling;
+	unsigned int(1)     videoFullRangeFlag;*/
+	u8   bit_depth;
+	u8   chroma_subsampling;
+	Bool video_fullRange_flag;
+
+	u8  colour_primaries;
+	u8  transfer_characteristics;
+	u8  matrix_coefficients;
+
+	/* MUST be 0 for VP8 and VP9 */
+	u16 codec_initdata_size;
+	u8* codec_initdata;
+} GF_VPConfig;
+
 /*! Media Segment Descriptor used for Media Control Extensions*/
 typedef struct
 {
@@ -1335,6 +1358,15 @@ GF_Err gf_odf_av1_cfg_write(GF_AV1Config *cfg, char **outData, u32 *outSize);
 GF_Err gf_odf_av1_cfg_write_bs(GF_AV1Config *cfg, GF_BitStream *bs);
 
 
+/* VP8-9 descriptors functions */
+GF_VPConfig *gf_odf_vp_cfg_new();
+void gf_odf_vp_cfg_del(GF_VPConfig *cfg);
+GF_Err gf_odf_vp_cfg_write_bs(GF_VPConfig *cfg, GF_BitStream *bs);
+GF_Err gf_odf_vp_cfg_write(GF_VPConfig *cfg, char **outData, u32 *outSize);
+GF_VPConfig *gf_odf_vp_cfg_read_bs(GF_BitStream *bs);
+GF_VPConfig *gf_odf_vp_cfg_read(char *dsi, u32 dsi_size);
+
+
 /*! destroy the descriptors in a list but not the list
  \param descList descriptor list to destroy
  \return error if any
diff --git a/src/isomedia/avc_ext.c b/src/isomedia/avc_ext.c
index 2f5a0de346..e59788eb23 100644
--- a/src/isomedia/avc_ext.c
+++ b/src/isomedia/avc_ext.c
@@ -1254,6 +1254,25 @@ void AV1_RewriteESDescriptor(GF_MPEGVisualSampleEntryBox *av1)
 }
 
 
+static GF_VPConfig* VP_DuplicateConfig(GF_VPConfig const * const cfg) {
+	u32 i = 0;
+	GF_VPConfig *out = gf_odf_vp_cfg_new();
+	if (out) {
+		out->profile = cfg->profile;
+		out->level = cfg->level;
+		out->bit_depth = cfg->bit_depth;
+		out->chroma_subsampling = cfg->chroma_subsampling;
+		out->video_fullRange_flag = cfg->video_fullRange_flag;
+		out->colour_primaries = cfg->colour_primaries;
+		out->transfer_characteristics = cfg->transfer_characteristics;
+		out->matrix_coefficients = cfg->matrix_coefficients;
+
+
+	}
+
+	return out;
+}
+
 #ifndef GPAC_DISABLE_ISOM_WRITE
 GF_EXPORT
 GF_Err gf_isom_avc_config_new(GF_ISOFile *the_file, u32 trackNumber, GF_AVCConfig *cfg, char *URLname, char *URNname, u32 *outDescriptionIndex)
@@ -1951,6 +1970,17 @@ GF_AV1Config *gf_isom_av1_config_get(GF_ISOFile *the_file, u32 trackNumber, u32
 	return AV1_DuplicateConfig(entry->av1_config->config);
 }
 
+GF_EXPORT
+GF_VPConfig *gf_isom_vp_config_get(GF_ISOFile *the_file, u32 trackNumber, u32 DescriptionIndex)
+{
+	GF_TrackBox *trak;
+	GF_MPEGVisualSampleEntryBox *entry;
+	trak = gf_isom_get_track_from_file(the_file, trackNumber);
+	if (!trak || !trak->Media || !DescriptionIndex) return NULL;
+	entry = (GF_MPEGVisualSampleEntryBox*)gf_list_get(trak->Media->information->sampleTable->SampleDescription->other_boxes, DescriptionIndex - 1);
+	if (!entry || !entry->vp_config) return NULL;
+	return VP_DuplicateConfig(entry->vp_config->config);
+}
 
 GF_EXPORT
 u32 gf_isom_get_avc_svc_type(GF_ISOFile *the_file, u32 trackNumber, u32 DescriptionIndex)
@@ -2479,7 +2509,7 @@ GF_Err av1c_Read(GF_Box *s, GF_BitStream *bs) {
 	u8 reserved;
 	u64 read = 0;
 	GF_AV1ConfigurationBox *ptr = (GF_AV1ConfigurationBox*)s;
-	
+
 	if (ptr->config) gf_odf_av1_cfg_del(ptr->config);
 	GF_SAFEALLOC(ptr->config, GF_AV1Config);
 	memset(&state, 0, sizeof(AV1State));
@@ -2502,7 +2532,7 @@ GF_Err av1c_Read(GF_Box *s, GF_BitStream *bs) {
 		u64 pos, obu_size;
 		ObuType obu_type;
 		GF_AV1_OBUArrayEntry *a;
-		
+
 		pos = gf_bs_get_position(bs);
 		obu_size = 0;
 		if (gf_media_aom_av1_parse_obu(bs, &obu_type, &obu_size, NULL, &state) != GF_OK) {
@@ -2566,6 +2596,81 @@ GF_Err av1c_Size(GF_Box *s) {
 
 #endif /*GPAC_DISABLE_ISOM_WRITE*/
 
+
+
+
+void vpcc_del(GF_Box *s)
+{
+	GF_VPConfigurationBox *ptr = (GF_VPConfigurationBox*)s;
+	if (ptr->config) gf_odf_vp_cfg_del(ptr->config);
+	ptr->config = NULL;
+	gf_free(ptr);
+}
+
+GF_Err vpcc_Read(GF_Box *s, GF_BitStream *bs)
+{
+	u64 pos;
+	GF_VPConfigurationBox *ptr = (GF_VPConfigurationBox *)s;
+
+	if (ptr->config) gf_odf_vp_cfg_del(ptr->config);
+	ptr->config = NULL;
+
+	pos = gf_bs_get_position(bs);
+	ptr->config = gf_odf_vp_cfg_read_bs(bs);
+	pos = gf_bs_get_position(bs) - pos ;
+
+	if (pos < ptr->size)
+		GF_LOG(GF_LOG_WARNING, GF_LOG_CONTAINER, ("[ISOBMFF] VPConfigurationBox: read only "LLU" bytes (expected "LLU").\n", pos, ptr->size));
+	if (pos > ptr->size)
+		GF_LOG(GF_LOG_ERROR, GF_LOG_CONTAINER, ("[ISOBMFF] VPConfigurationBox overflow read "LLU" bytes, of box size "LLU".\n", pos, ptr->size));
+
+	return ptr->config ? GF_OK : GF_ISOM_INVALID_FILE;
+}
+
+GF_Box *vpcc_New()
+{
+	GF_VPConfigurationBox *tmp = (GF_VPConfigurationBox *) gf_malloc(sizeof(GF_VPConfigurationBox));
+	if (tmp == NULL) return NULL;
+	memset(tmp, 0, sizeof(GF_VPConfigurationBox));
+	tmp->type = GF_ISOM_BOX_TYPE_VPCC;
+	return (GF_Box *)tmp;
+}
+
+#ifndef GPAC_DISABLE_ISOM_WRITE
+GF_Err vpcc_Write(GF_Box *s, GF_BitStream *bs)
+{
+	GF_Err e;
+	GF_VPConfigurationBox *ptr = (GF_VPConfigurationBox *) s;
+	if (!s) return GF_BAD_PARAM;
+	if (!ptr->config) return GF_OK;
+	e = gf_isom_full_box_write(s, bs);
+	if (e) return e;
+
+	return gf_odf_vp_cfg_write_bs(ptr->config, bs);
+}
+#endif
+
+GF_Err vpcc_Size(GF_Box *s)
+{
+	GF_VPConfigurationBox *ptr = (GF_VPConfigurationBox *)s;
+
+	if (!ptr->config) {
+		ptr->size = 0;
+		return GF_OK;
+	}
+
+	if (ptr->config->codec_initdata_size) {
+		GF_LOG(GF_LOG_ERROR, GF_LOG_CONTAINER, ("[ISOBMFF] VPConfigurationBox: codec_initdata_size MUST be 0, was %d\n", ptr->config->codec_initdata_size));
+		return GF_ISOM_INVALID_FILE;
+	}
+
+	ptr->size += 8;
+
+	return GF_OK;
+}
+
+
+
 GF_OperatingPointsInformation *gf_isom_oinf_new_entry()
 {
 	GF_OperatingPointsInformation* ptr;
diff --git a/src/isomedia/box_code_base.c b/src/isomedia/box_code_base.c
index 38dda9aa56..1d952a1b20 100644
--- a/src/isomedia/box_code_base.c
+++ b/src/isomedia/box_code_base.c
@@ -4159,6 +4159,7 @@ void video_sample_entry_del(GF_Box *s)
 	if (ptr->hevc_config) gf_isom_box_del((GF_Box *) ptr->hevc_config);
 	if (ptr->lhvc_config) gf_isom_box_del((GF_Box *) ptr->lhvc_config);
 	if (ptr->av1_config) gf_isom_box_del((GF_Box *)ptr->av1_config);
+	if (ptr->vp_config) gf_isom_box_del((GF_Box *)ptr->vp_config);
 	if (ptr->cfg_3gpp) gf_isom_box_del((GF_Box *)ptr->cfg_3gpp);
 
 	if (ptr->descr) gf_isom_box_del((GF_Box *) ptr->descr);
@@ -4212,6 +4213,10 @@ GF_Err video_sample_entry_AddBox(GF_Box *s, GF_Box *a)
 		if (ptr->av1_config) ERROR_ON_DUPLICATED_BOX(a, ptr)
 			ptr->av1_config = (GF_AV1ConfigurationBox *)a;
 		break;
+	case GF_ISOM_BOX_TYPE_VPCC:
+		if (ptr->vp_config) ERROR_ON_DUPLICATED_BOX(a, ptr)
+			ptr->vp_config = (GF_VPConfigurationBox *)a;
+		break;
 	case GF_ISOM_BOX_TYPE_M4DS:
 		if (ptr->descr) ERROR_ON_DUPLICATED_BOX(a, ptr)
 			ptr->descr = (GF_MPEG4ExtensionDescriptorsBox *)a;
@@ -4333,6 +4338,10 @@ GF_Err video_sample_entry_Write(GF_Box *s, GF_BitStream *bs)
 			e = gf_isom_box_write((GF_Box *)ptr->av1_config, bs);
 			if (e) return e;
 		}
+		if (ptr->vp_config && ptr->vp_config->config) {
+			e = gf_isom_box_write((GF_Box *)ptr->vp_config, bs);
+			if (e) return e;
+		}
 	}
 	if (ptr->pasp) {
 		e = gf_isom_box_write((GF_Box *)ptr->pasp, bs);
@@ -4369,7 +4378,7 @@ GF_Err video_sample_entry_Size(GF_Box *s)
 		if (e) return e;
 		ptr->size += ptr->cfg_3gpp->size;
 	} else {
-		if (!ptr->avc_config && !ptr->svc_config && !ptr->hevc_config && !ptr->lhvc_config && (ptr->type!=GF_ISOM_BOX_TYPE_HVT1) && !ptr->av1_config ) {
+		if (!ptr->avc_config && !ptr->svc_config && !ptr->hevc_config && !ptr->lhvc_config && (ptr->type!=GF_ISOM_BOX_TYPE_HVT1) && !ptr->av1_config && !ptr->vp_config ) {
 			return GF_ISOM_INVALID_FILE;
 		}
 
@@ -4402,13 +4411,19 @@ GF_Err video_sample_entry_Size(GF_Box *s)
 			if (e) return e;
 			ptr->size += ptr->lhvc_config->size;
 		}
-		
+
 		if (ptr->av1_config && ptr->av1_config->config) {
 			e = gf_isom_box_size((GF_Box *)ptr->av1_config);
 			if (e) return e;
 			ptr->size += ptr->av1_config->size;
 		}
 
+		if (ptr->vp_config && ptr->vp_config->config) {
+			e = gf_isom_box_size((GF_Box *)ptr->vp_config);
+			if (e) return e;
+			ptr->size += ptr->vp_config->size;
+		}
+
 		if (ptr->ipod_ext) {
 			e = gf_isom_box_size((GF_Box *) ptr->ipod_ext);
 			if (e) return e;
@@ -6818,6 +6833,8 @@ static void gf_isom_check_sample_desc(GF_TrackBox *trak)
 		case GF_ISOM_BOX_TYPE_LHV1:
 		case GF_ISOM_BOX_TYPE_LHE1:
 		case GF_ISOM_BOX_TYPE_AV01:
+		case GF_ISOM_BOX_TYPE_VP08:
+		case GF_ISOM_BOX_TYPE_VP09:
 		case GF_ISOM_BOX_TYPE_AV1C:
 		case GF_ISOM_BOX_TYPE_TX3G:
 		case GF_ISOM_BOX_TYPE_TEXT:
@@ -6838,7 +6855,7 @@ static void gf_isom_check_sample_desc(GF_TrackBox *trak)
 		case GF_ISOM_BOX_TYPE_MHM1:
 		case GF_ISOM_BOX_TYPE_MHM2:
 			continue;
-			
+
 		case GF_ISOM_BOX_TYPE_UNKNOWN:
 			break;
 		default:
diff --git a/src/isomedia/box_dump.c b/src/isomedia/box_dump.c
index cdf3bb55f0..7fe2dc229e 100644
--- a/src/isomedia/box_dump.c
+++ b/src/isomedia/box_dump.c
@@ -1608,6 +1608,29 @@ GF_Err av1c_dump(GF_Box *a, FILE *trace) {
 	return GF_OK;
 }
 
+
+GF_Err vpcc_dump(GF_Box *a, FILE *trace) {
+	GF_VPConfigurationBox *ptr = (GF_VPConfigurationBox*)a;
+	fprintf(trace, "<VPConfigurationBox>\n");
+	if (ptr->config) {
+		fprintf(trace, "<VPConfig");
+
+		fprintf(trace, " profile=\"%u\"", ptr->config->profile);
+		fprintf(trace, " level=\"%u\"", ptr->config->level);
+		fprintf(trace, " bit_depth=\"%u\"", ptr->config->bit_depth);
+		fprintf(trace, " chroma_subsampling=\"%u\"", ptr->config->chroma_subsampling);
+		fprintf(trace, " video_fullRange_flag=\"%u\"", ptr->config->video_fullRange_flag);
+		fprintf(trace, " colour_primaries=\"%u\"", ptr->config->colour_primaries);
+		fprintf(trace, " transfer_characteristics=\"%u\"", ptr->config->transfer_characteristics);
+		fprintf(trace, " matrix_coefficients=\"%u\"", ptr->config->matrix_coefficients);
+		fprintf(trace, " codec_initdata_size=\"%u\"", ptr->config->codec_initdata_size);
+
+		fprintf(trace, ">\n</VPConfig>\n");
+	}
+	fprintf(trace, "</VPConfigurationBox>\n");
+	return GF_OK;
+}
+
 GF_Err m4ds_dump(GF_Box *a, FILE * trace)
 {
 	u32 i;
diff --git a/src/isomedia/box_funcs.c b/src/isomedia/box_funcs.c
index 7df7827969..3e0dcaa63f 100644
--- a/src/isomedia/box_funcs.c
+++ b/src/isomedia/box_funcs.c
@@ -632,6 +632,7 @@ ISOM_BOX_IMPL_DECL(cslg)
 ISOM_BOX_IMPL_DECL(ccst)
 ISOM_BOX_IMPL_DECL(hvcc)
 ISOM_BOX_IMPL_DECL(av1c)
+ISOM_BOX_IMPL_DECL(vpcc)
 ISOM_BOX_IMPL_DECL(prft)
 
 ISOM_BOX_IMPL_DECL(trep)
@@ -1026,6 +1027,11 @@ static const struct box_registry_entry {
 	BOX_DEFINE_S(GF_ISOM_BOX_TYPE_AV01, video_sample_entry, "stsd", "av1"),
 	FBOX_DEFINE_FLAGS_S(GF_ISOM_BOX_TYPE_AV1C, av1c, "av01 encv resv", 0, 0, "av1"),
 
+	// VP8-9 boxes
+	FBOX_DEFINE_FLAGS_S( GF_ISOM_BOX_TYPE_VPCC, vpcc, "vp08 vp09", 1, 0, "vp"),
+	BOX_DEFINE_S( GF_ISOM_BOX_TYPE_VP08, video_sample_entry, "stsd", "vp"),
+	BOX_DEFINE_S( GF_ISOM_BOX_TYPE_VP09, video_sample_entry, "stsd", "vp"),
+
 	//part20 boxes
 	BOX_DEFINE_S( GF_ISOM_BOX_TYPE_LSR1, lsr1, "stsd", "p20"),
 	BOX_DEFINE_S( GF_ISOM_BOX_TYPE_LSRC, lsrc, "lsr1", "p20"),
diff --git a/src/media_tools/dash_segmenter.c b/src/media_tools/dash_segmenter.c
index aa3d970279..b53b45602c 100644
--- a/src/media_tools/dash_segmenter.c
+++ b/src/media_tools/dash_segmenter.c
@@ -675,7 +675,7 @@ GF_Err gf_media_get_rfc_6381_codec_name(GF_ISOFile *movie, u32 track, char *szCo
 			av1_state.seq_profile, av1_state.seq_level_idx, av1_state.bit_depth,
 			av1_state.mono_chrome,
 			av1_state.chroma_subsampling_x, av1_state.chroma_subsampling_y, av1_state.chroma_sample_position);
-			
+
 		if (av1_state.color_description_present_flag) {
 			char tmp[RFC6381_CODEC_NAME_SIZE_MAX];
 			snprintf(tmp, RFC6381_CODEC_NAME_SIZE_MAX, "%01u.%01u.%01u.%01u", av1_state.color_primaries, av1_state.transfer_characteristics, av1_state.matrix_coefficients, av1_state.color_range);
@@ -695,6 +695,34 @@ GF_Err gf_media_get_rfc_6381_codec_name(GF_ISOFile *movie, u32 track, char *szCo
 	}
 #endif /*GPAC_DISABLE_AV1*/
 
+
+	case GF_ISOM_SUBTYPE_VP08:
+	case GF_ISOM_SUBTYPE_VP09:
+	{
+		GF_VPConfig *vpcc = NULL;
+
+		vpcc = gf_isom_vp_config_get(movie, track, 1);
+		if (!vpcc) {
+			GF_LOG(GF_LOG_DEBUG, GF_LOG_AUTHOR, ("[ISOM Tools] No config found for VP file (\"%s\") when computing RFC6381.\n", gf_4cc_to_str(subtype)));
+			return GF_BAD_PARAM;
+		}
+
+		snprintf(szCodec, RFC6381_CODEC_NAME_SIZE_MAX, "%s.%02u.%02u.%02u.%02u.%02u.%02u.%02u.%02u", gf_4cc_to_str(subtype),
+			vpcc->profile,
+			vpcc->level,
+			vpcc->bit_depth,
+			vpcc->chroma_subsampling,
+			vpcc->colour_primaries,
+			vpcc->transfer_characteristics,
+			vpcc->matrix_coefficients,
+			vpcc->video_fullRange_flag);
+
+
+		gf_odf_vp_cfg_del(vpcc);
+
+		return GF_OK;
+	}
+
 	default:
 		GF_LOG(GF_LOG_DEBUG, GF_LOG_AUTHOR, ("[ISOM Tools] codec parameters not known - setting codecs string to default value \"%s\"\n", gf_4cc_to_str(subtype) ));
 		snprintf(szCodec, RFC6381_CODEC_NAME_SIZE_MAX, "%s", gf_4cc_to_str(subtype));
diff --git a/src/odf/descriptors.c b/src/odf/descriptors.c
index 11ffeb74e6..f1499eaeda 100644
--- a/src/odf/descriptors.c
+++ b/src/odf/descriptors.c
@@ -1126,6 +1126,110 @@ GF_Err gf_odf_av1_cfg_write(GF_AV1Config *cfg, char **outData, u32 *outSize) {
 }
 
 
+
+GF_EXPORT
+GF_VPConfig *gf_odf_vp_cfg_new()
+{
+	GF_VPConfig *cfg;
+	GF_SAFEALLOC(cfg, GF_VPConfig);
+	if (!cfg) return NULL;
+	cfg->codec_initdata_size = 0;
+	cfg->codec_initdata = NULL;
+	return cfg;
+}
+
+GF_EXPORT
+void gf_odf_vp_cfg_del(GF_VPConfig *cfg)
+{
+	if (!cfg) return;
+
+	if (cfg->codec_initdata) {
+		gf_free(cfg->codec_initdata);
+		cfg->codec_initdata = NULL;
+	}
+
+	gf_free(cfg);
+}
+
+GF_EXPORT
+GF_Err gf_odf_vp_cfg_write_bs(GF_VPConfig *cfg, GF_BitStream *bs)
+{
+
+	gf_bs_write_int(bs, cfg->profile, 8);
+	gf_bs_write_int(bs, cfg->level, 8);
+	gf_bs_write_int(bs, cfg->bit_depth, 4);
+	gf_bs_write_int(bs, cfg->chroma_subsampling, 3);
+	gf_bs_write_int(bs, cfg->video_fullRange_flag, 1);
+	gf_bs_write_int(bs, cfg->colour_primaries, 8);
+	gf_bs_write_int(bs, cfg->transfer_characteristics, 8);
+	gf_bs_write_int(bs, cfg->matrix_coefficients, 8);
+
+	if (cfg->codec_initdata_size) {
+		GF_LOG(GF_LOG_WARNING, GF_LOG_CONTAINER, ("[iso file] VP Configuration Box: invalid data, codec_initdata_size must be 0, was %d - ignoring\n", cfg->codec_initdata_size));
+	}
+
+	gf_bs_write_int(bs, (u16)0, 16);
+
+	return GF_OK;
+}
+
+GF_EXPORT
+GF_Err gf_odf_vp_cfg_write(GF_VPConfig *cfg, char **outData, u32 *outSize)
+{
+	GF_Err e;
+	GF_BitStream *bs = gf_bs_new(NULL, 0, GF_BITSTREAM_WRITE);
+	*outSize = 0;
+	*outData = NULL;
+	e = gf_odf_vp_cfg_write_bs(cfg, bs);
+	if (e==GF_OK)
+		gf_bs_get_content(bs, outData, outSize);
+
+	gf_bs_del(bs);
+	return e;
+}
+
+GF_EXPORT
+GF_VPConfig *gf_odf_vp_cfg_read_bs(GF_BitStream *bs)
+{
+	GF_VPConfig *cfg = gf_odf_vp_cfg_new();
+
+	cfg->profile = gf_bs_read_int(bs, 8);
+	cfg->level = gf_bs_read_int(bs, 8);
+
+	cfg->bit_depth = gf_bs_read_int(bs, 4);
+	cfg->chroma_subsampling = gf_bs_read_int(bs, 3);
+	cfg->video_fullRange_flag = gf_bs_read_int(bs, 1);
+
+
+	cfg->colour_primaries = gf_bs_read_int(bs, 8);
+	cfg->transfer_characteristics = gf_bs_read_int(bs, 8);
+	cfg->matrix_coefficients = gf_bs_read_int(bs, 8);
+
+	cfg->codec_initdata_size = gf_bs_read_int(bs, 16);
+
+	// must be 0 according to spec
+	if (cfg->codec_initdata_size) {
+		GF_LOG(GF_LOG_ERROR, GF_LOG_CONTAINER, ("[iso file] VP Configuration Box: invalid data, codec_initdata_size must be 0, was %d\n", cfg->codec_initdata_size));
+		gf_odf_vp_cfg_del(cfg);
+		return NULL;
+	}
+
+	return cfg;
+
+}
+
+GF_EXPORT
+GF_VPConfig *gf_odf_vp_cfg_read(char *dsi, u32 dsi_size)
+{
+	GF_BitStream *bs = gf_bs_new(dsi, dsi_size, GF_BITSTREAM_READ);
+	GF_VPConfig *cfg = gf_odf_vp_cfg_read_bs(bs);
+	gf_bs_del(bs);
+	return cfg;
+}
+
+
+
+
 GF_EXPORT
 const char *gf_afx_get_type_description(u8 afx_code)
 {
